tinyMCEPopup.requireLangPack();

var action, orgTableWidth, orgTableHeight, dom = tinyMCEPopup.editor.dom;

function insertTable() {
	var formObj = document.forms[0];
	var inst = tinyMCEPopup.editor, dom = inst.dom;
	var html = '', elm;

	tinyMCEPopup.restoreSelection();

	if (!AutoValidator.validate(formObj)) {
		alert(inst.getLang('table.invalid_table_field'));
		return false;
	}

	elm = dom.getParent(inst.selection.getNode(), 'table');

	// Get form data
	var cols = formObj.elements['cols'].value;
	var rows = formObj.elements['rows'].value;
    var heading = formObj.elements['heading'].checked;

	// Create new table
    var tableId = "conftable_" + new Date().getTime();
	html += '<table';
    html += makeAttrib('id', tableId);
    html += makeAttrib('class', tinyMCE.settings.confluence_table_style);
    html += '>';

    var inner = (tinymce.isIE ? "" : "<br mce_bogus='1'/>"); 

    for (var y=0; y<rows; y++) {
		html += "<tr>";

		for (var x=0; x<cols; x++) {
            if (heading && y == 0) {
                html += "<th class='" + tinyMCE.settings.confluence_table_header_style + "'>" + inner + "</th>"
            }
            else {
                html += "<td class='" + tinyMCE.settings.confluence_table_cell_style + "'>" + inner + "</td>";
            }
		}

		html += "</tr>";
	}

	html += "</table>";

    if (tinymce.isGecko) { // Padd the end of a table in Gecko otherwise it is impossible to place the caret there
        html += "<br mce_bogus='1'/>";
    }
    
    inst.execCommand('mceBeginUndoLevel');
	inst.execCommand('mceInsertContent', false, html);
	inst.addVisual();
	inst.execCommand('mceEndUndoLevel');

    // give focus to first cell
    var node = inst.dom.select("#" + tableId + " tr")[0].firstChild;
    inst.selection.select(node);
    inst.nodeChanged();

    tinyMCEPopup.close();
}

function makeAttrib(attrib, value) {
	var formObj = document.forms[0];
	var valueElm = formObj.elements[attrib];

	if (typeof(value) == "undefined" || value == null) {
		value = "";

		if (valueElm)
			value = valueElm.value;
	}

	if (value == "")
		return "";

	// XML encode it
	value = value.replace(/&/g, '&amp;');
	value = value.replace(/\"/g, '&quot;');
	value = value.replace(/</g, '&lt;');
	value = value.replace(/>/g, '&gt;');

	return ' ' + attrib + '="' + value + '"';
}

function init() {
    // todo check whether this is a good idea.  Is it only necessary if you're
    // internationalising?
    tinyMCEPopup.resizeToInnerSize();

    var formObj = document.forms[0];
    formObj.cols.value = tinyMCE.settings.confluence_table_default_rows;
    formObj.rows.value = tinyMCE.settings.confluence_table_default_cols;
    formObj.heading.checked = tinyMCE.settings.confluence_table_default_heading;
}
tinyMCEPopup.onInit.add(init);
